@echo off
rem maq.bat [-debug] file.pq [file.q]
rem ---------------------------------
rem pre-requisites:
rem   python, MinGW gcc, tr, grep, sed
rem   .\align.py .\comment.py .\consts.py .\eval.py .\expand.py .\replace2.py
rem   .\settings.bat
rem -------------------------------------------------------------------------

rem #!/bin/bash
rem 
rem # Author: Peter Schwabe
rem # Date: 2009-03-19
rem # Public domain

rem MAQDIR=$(dirname $0)
set MAQDIR=%~dp0
set MAQDIR=%MAQDIR:~0,-1%
call "%MAQDIR%\settings.bat" 

rem $MAQDIR/expand.py $1 \
rem | $MAQDIR/comment.py \
rem | gcc -C -E - \
rem | tr ";" "\n" \
rem | grep -v ^# \
rem | $MAQDIR/eval.py \
rem | $MAQDIR/replace2.py \
rem | $MAQDIR/align.py \
rem | sed "s/\\\//"

set DBG=N& set DBS=
for %%p in (DBG DEB DEBUG) do if /i "%1" == "-%%p" set DBG=Y& set DBS= -debug& shift

set O=%~n1
set QO=%2
if "" == "%QO%" set QO=%O%.q

if /i "Y" == "%DBG%" type         %1            > %O%.0.pq
echo maq%DBS% %1:

echo   expand
%PYTHON% "%MAQDIR%\expand.py"     %1            > %O%.1.expand

echo   comment
%PYTHON% "%MAQDIR%\comment.py"  < %O%.1.expand  > %O%.2.c

echo   gcc
%GCC% -C -E                       %O%.2.c       > %O%.3.gcc

echo   tr
%TR% ";" "\n"                   < %O%.3.gcc     > %O%.4.tr

echo   grep
%GREP% -v "^#"                  < %O%.4.tr      > %O%.5.grep

echo   eval
%PYTHON% "%MAQDIR%\eval.py"     < %O%.5.grep    > %O%.6.eval

echo   replace
%PYTHON% "%MAQDIR%\replace2.py" < %O%.6.eval    > %O%.7.replace

echo   align
%PYTHON% "%MAQDIR%\align.py"    < %O%.7.replace > %O%.8.align

echo   sed
%SED% "s/\\//"                  < %O%.8.align   > %QO%

if /i not "Y" == "%DBG%" for %%f in (
  %O%.0.pq %O%.1.expand %O%.2.c %O%.3.gcc %O%.4.tr %O%.5.grep %O%.6.eval %O%.7.replace %O%.8.align %O%.9.q
) do if exist %%f del /q %%f >NUL
