#!/usr/bin/env perl

# NOT FINISHED yet (anybody welcome ...)
# use qhasm.bat istead (it should work, if bunch of required tools preinstalled)

my $AWK = 'gawk.exe';
my $CPP = 'gcc.exe -C -E';
my $ASM = 'gcc.exe -x assembler';

my $CPU = "";  # try to detect
my $ACT = 's'; # default is translation to assembler code

my ($prog, $vers, $d_b_vers) = ('qhasm', '1.0', '2007-02-07');

my $usage = "
Usage:
  $prog -S [Options] qhasm_file.s           -- clean qhasm comments (leave assembler)
  $prog -Q [Options] qhasm_file.s           -- recover qhasm code (leave qhasm)
  $prog -P [Options] qhasm_file             -- preprocess only
  $prog -s [-Platform] [Options] qhasm_file -- compile to assembler file
  $prog -c [-Platform] [Options] qhasm_file -- compile to object file
  $prog --help                              -- this help screen
  $prog --version                           -- show program version(s)

Platform:
  x86 amd64

Options:
  -o output_file -- set output file name
  --keep_stage   -- keep stage files
  -v[0123]       -- verbose (default is 2)
";

my ($src, $out, $keep, $stage, $verb, $nfiles) = ("", "", 0, "", 2, 0, @S, @O);

sub split_text($$);
sub compile_qa($$$$);

my ($o, $v);
while (scalar(@ARGV) > 0)
{
   $o = shift @ARGV; $v = scalar(@ARGV) > 0 ? $ARGV[0] : "";
   if    ( $o =~ m!^-([SQPsc])$!o ) { $ACT = $1; }
   elsif ( $o =~ m!^-x86$!io ) { $CPU = 'X86'; }
   elsif ( $o =~ m!^-AMD64$!io ) { $CPU = 'AMD64'; }
   elsif ( $o =~ m!^-o$!o ) { die $usage unless defined($v); $out = $v; shift @ARGV; }
   elsif ( $o =~ m!^--keep-stage$!o ) { $keep = 1; }
   elsif ( $o =~ m!^-v([0123])$!o ) { $verb = $1; }
   elsif ( $o =~ m!^(-h|--h|-help|--help)$!o ) { print $usage; exit 0; }
   elsif ( $o =~ m!^(--version|--vers|--v|-V)$!o ) { 
      print "\n", "script version: $vers\n\n";
      print "qhasm version: $d_b_vers\n\n";
      print `$AWK --version`, "\n";
      print `$CPP --version`;
      exit 0;
   }
   else {
      ++$nfiles;
      open(SRC, "<", $src = $o) || die "Can't open: $src -- $!";
      @S = <SRC>;
      close SRC;
      $o = $out;
      if ( $ACT eq 'S' ) {
         @O = split_text("extract_s", 's');
      }
      elsif ( $ACT eq 'Q' ) {
         @O = split_text("extract_q", '');
      }
      elsif ( $ACT eq 'P' ) {
         @O = compile_qa("preprocess", 1, 0, 0);
      }
      elsif ( $ACT eq 'c' ) {
         @O = compile_qa("compile_asm", 1, 1, 1);
         $o = "$src.o" unless( $o );
      }
      else { # 's'
         @O = compile_qa("compile_obj", 1, 1, 0);
      }
      unless ( $o ) { print @O; } else {
         open(OUT, ">", $o) || die "Can't create: $o -- $!";
         print OUT @O;
         close OUT;
      }
   }
} 

#============================================================================================

sub split_text($$)
{
   my ($op, $asm) = @_;
   my @o = ();
   foreach my $s (@S) {
      next if ( $s =~ m!^\s*$!o );
      if ( $s =~ m!^# translated by !o ) { push @o, "\n"; next; }
 
      if ( $s =~ m!^[#;]# !o ) {
         next if $asm;
         next unless $s =~ m!^[#;]# input line \d+: (.*\s*)$!o;
         $s = $1;
         push @o, $s;
         next;
      }
      if ( $s =~ m!^[#;]!o ) { push @o, $s; } elsif ( $asm ) {
         push @o, $s;
         push @o, "\n" if ($s eq 'ret');
      }
   }
   return @o;
}

#============================================================================================

sub compile_qa($$$$)
{
   my ($op, $preppoc, $makeasm, $makeobj) = @_;
   return @S;
}

#============================================================================================

die $usage unless $nfiles;
exit 0;
          
__DATA__

#!/bin/sh
sed 's/#.*//' \
| sed 's/:/#/g' \
| cat X86 - \
| ./qhasm-ops \
| ./qhasm-regs \
| ./qhasm-fp \
| ./qhasm-as \
| sed 's/%eax%8/%al/g' \
| sed 's/%ebx%8/%bl/g' \
| sed 's/%ecx%8/%cl/g' \
| sed 's/%edx%8/%dl/g' \
| sed 's/%eax%next8/%ah/g' \
| sed 's/%ebx%next8/%bh/g' \
| sed 's/%ecx%next8/%ch/g' \
| sed 's/%edx%next8/%dh/g'


#!/bin/sh
sed 's/#.*//' \
| sed 's/:/#/g' \
| cat AMD64 - \
| ./qhasm-ops \
| ./qhasm-regs \
| ./qhasm-fp \
| ./qhasm-as \
| sed 's/%32/d/g' \
| sed 's/%raxd/%eax/g' \
| sed 's/%rbxd/%ebx/g' \
| sed 's/%rcxd/%ecx/g' \
| sed 's/%rdxd/%edx/g' \
| sed 's/%rsid/%esi/g' \
| sed 's/%rdid/%edi/g' \
| sed 's/%rbpd/%ebp/g' \
| sed 's/%16/w/g' \
| sed 's/%raxw/%ax/g' \
| sed 's/%rbxw/%bx/g' \
| sed 's/%rcxw/%cx/g' \
| sed 's/%rdxw/%dx/g' \
| sed 's/%rsiw/%si/g' \
| sed 's/%rdiw/%di/g' \
| sed 's/%rbpw/%bp/g' \
| sed 's/%8/b/g' \
| sed 's/%raxb/%al/g' \
| sed 's/%rbxb/%bl/g' \
| sed 's/%rcxb/%cl/g' \
| sed 's/%rdxb/%dl/g' \
| sed 's/%rsib/%sil/g' \
| sed 's/%rdib/%dil/g' \
| sed 's/%rbpb/%bpl/g' \
| sed 's/%rax%next8/%ah/g' \
| sed 's/%rbx%next8/%bh/g' \
| sed 's/%rcx%next8/%ch/g' \
| sed 's/%rdx%next8/%dh/g'

#!/bin/sh
sed 's/#.*//' \
| sed 's/:/#/g' \
| cat SPARC - \
| ./qhasm-ops \
| ./qhasm-regs \
| grep -v '^op:livefloat80:' \
| ./qhasm-as

#!/bin/sh
sed 's/#.*//' \
| sed 's/:/#/g' \
| cat PPC32-LINUX - \
| ./qhasm-ops \
| ./qhasm-regs \
| grep -v '^op:livefloat80:' \
| ./qhasm-as

#!/bin/sh
sed 's/#.*//' \
| sed 's/:/#/g' \
| cat PPC32-MACOS - \
| ./qhasm-ops \
| ./qhasm-regs \
| grep -v '^op:livefloat80:' \
| ./qhasm-as \
| sed 's/^# /; /'
