@echo off
  call %~dp0init.bat
  set sdir=%proj%-%vers%
  if not exist %sdir%\ echo.& echo ERROR: '%sdir%\' does not exist& goto :EOF

  set odir=src
  set tdir=tst
  set bdir=bin
  if not exist %odir%\ call :run md %odir%
  if not exist %tdir%\ call :run md %tdir%
  if not exist %bdir%\ call :run md %bdir%

  rem copy processor definition files
  rem
  for %%p in (AMD64 PPC32-LINUX PPC32-MACOS X86 SPARC) do call :copy_def %%p

  rem copy awk scripts
  rem
  for %%a in (qhasm-as qhasm-fp) do call :copy_awk %sdir%\%%a %bdir%\%%a.awk

  rem simple copy
  rem
  for %%f in (
    critbit0.h critbit0_allprefixed.c critbit0_clear.c critbit0_contains.c critbit0_delete.c
    critbit0_firstprefixed.c critbit0_insert.c
    limitmalloc.h
    limitmalloc_close.c limitmalloc_open.c limitmalloc_open_if2.c
    str0.h 
    str0_colon.c str0_concat.c str0_concatc.c str0_copy.c str0_copyc.c
    str0_copycl.c str0_equal.c str0_equalc.c str0_free.c str0_getline.c
    str0_increment.c str0_length.c str0_putline.c str0_uint64.c str0_word.c
    limitmalloc-test1.c str0-test1.c str0-test2.c str0-test3.c str0-test4.c str0-test5.c
  ) do call :srun copy /y %sdir%\%%f %odir%\%%f

  rem append #include <stdlib.h>
  rem
  for %%f in (qhasm-ops.c qhasm-regs.c) do call :copy_stdlib %sdir%\%%f %odir%\%%f

  call :copy_random %sdir%\critbit0-test1.c %odir%\critbit0-test1.c 

  rem copy and rename
  rem
  call :srun copy /y %sdir%\int64.h_1-longlong  %odir%\int64.h 
  call :srun copy /y %sdir%\uint64.h_1-longlong %odir%\uint64.h 
  call :srun copy /y %sdir%\uint32.h_1-int      %odir%\uint32.h 
  call :srun copy /y %sdir%\uint8.h_1-char      %odir%\uint8.h 

  call :srun copy /y %sdir%\tests.exp %tdir%\tests.exp
  call :srun copy /y tests.bat        %tdir%\tests.bat

  call :srun copy /y compile.bat %odir%\compile.bat
  call :srun copy /y load.bat    %odir%\load.bat
  call :srun copy /y build.bat   %odir%\build.bat
goto :EOF

:copy_stdlib
  echo copy_stdlib: %1 %2
  echo #include ^<stdlib.h^> > %2
  type %1 >> %2
  call :srun wxlat.exe -du %2
goto :EOF

:copy_random
  echo copy_random: %1 %2
  echo #define random() rand() > %2
  type %1 >> %2
  call :srun wxlat.exe -du %2
goto :EOF

:copy_def
  set s=%sdir%\%1
  if exist %1.new set s=%1.new
  set o=%bdir%\%1.processor
  call :srun copy /y %s% %o%
goto :EOF

:copy_awk
  echo %1 : %2
  awk.exe "{ if (NR > 3 && length($0) != 1) print $0; }" %1 > %2
goto :EOF

:copy
  set from=%sdir%\%1
  set to=src\%~nx1
  if "%1" == "src\w32\subproc\misc.c" set to=src\misc1.c
  if "%1" == "src\config.h.W32" set to=src\config.h
  set cpy=wxlat.exe -ud
  if "%~x1" == ".ico" set cpy=copy /y
  call :run %cpy% %from% %to%
goto :EOF

:run
  set cmd=%*
  echo %cmd%
  %cmd%
goto :EOF

:srun
  set cmd=%*
  echo %cmd%
  %cmd% 1>NUL
goto :EOF
